Добавление настраиваемого сообщения в выброшенное исключение при сохранении трассировки стека в Java

У меня есть небольшой кусок кода, который проходит через некоторые транзакции для обработки. Каждая транзакция помечается номером транзакции, который генерируется внешней программой и не обязательно упорядочен. Когда я ловлю исключение в коде обработки, я выбрасываю его в основной класс и записываю его для последующего просмотра. Я'Я хотел бы добавить номер транзакции в это исключение. Возможно ли сделать это, сохраняя правильную трассировку стека?

Например:

public static void main(String[] args) {
    try{
        processMessage();
    }catch(Exception E){
        E.printStackTrace();
    }

}

private static void processMessage() throws Exception{
    String transNbr = "";
    try{
        transNbr = "2345";
        throw new Exception();
    }catch(Exception E){
        if(!transNbr.equals("")){
            //stack trace originates from here, not from actual exception
            throw new Exception("transction: " + transNbr); 
        }else{
            //stack trace gets passed correctly but no custom message available
            throw E;
        }
    }
}

Ответы на вопрос(6)

ЕстьException конструктор, который также принимает аргумент причины:Исключение (строковое сообщение, Throwable t).

Вы можете использовать его для распространения трассировки стека:

try{
    //...
}catch(Exception E){
    if(!transNbr.equals("")){
        throw new Exception("transaction: " + transNbr, E); 
    }
    //...
}

Исключения обычно неизменны: вы можетеизменить свое сообщение после того, как онибыл создан. Что вы можете сделать, это цепочка исключений:

throw new TransactionProblemException(transNbr, originalException);

Трассировка стека будет выглядеть

TransactionProblemException : transNbr
at ...
at ...
caused by OriginalException ...
at ...
at ...
 vikingsteve12 нояб. 2013 г., 09:58
Это лучше, так как имя класса исключения связано с доменом - это 's сразу же узнаваем именно источник проблемы. Плюс инструменты анализа кода могут выдавать предупреждения при вас.throw new Exception(...)

Вы можете использовать свое сообщение об исключении:

 public class MyNullPointException extends NullPointerException {

        private ExceptionCodes exceptionCodesCode;

        public MyNullPointException(ExceptionCodes code) {
            this.exceptionCodesCode=code;
        }
        @Override
        public String getMessage() {
            return exceptionCodesCode.getCode();
        }


   public class enum ExceptionCodes {
    COULD_NOT_SAVE_RECORD ("cityId:001(could.not.save.record)"),
    NULL_POINT_EXCEPTION_RECORD ("cityId:002(null.point.exception.record)"),
    COULD_NOT_DELETE_RECORD ("cityId:003(could.not.delete.record)");

    private String code;

    private ExceptionCodes(String code) {
        this.code = code;
    }

    public String getCode() {
        return code;
    }
}

Вы можете использовать super, расширяя Exception}}

if (pass.length() < minPassLength)
    throw new InvalidPassException("The password provided is too short");
 } catch (NullPointerException e) {
    throw new InvalidPassException("No password provided", e);
 }


// A custom business exception
class InvalidPassException extends Exception {

InvalidPassException() {

}

InvalidPassException(String message) {
    super(message);
}
InvalidPassException(String message, Throwable cause) {
   super(message, cause);
}

источник

Следующий код является простым примером, который работал для меня. Позвольте мне вызвать функциюmain в качестве родительской функции иdivide как дочерняя функция.

В основном явыбрасывая новое исключение смое специальное сообщение (для родителяs call), если в дочерней функции возникает исключениепоймать исключение у ребенка первым.

class Main {
    public static void main(String args[]) {
        try{
            long ans=divide(0);
            System.out.println("answer="+ans);
        }
        catch(Exception e){
            System.out.println("got exception:"+e.getMessage());

        }

   , }
    public static long divide(int num) throws Exception{
        long x=-1;
        try {
            x=5/num;
        }
        catch (Exception e){
            throw new Exception("Error occured in divide for number:"+num+"Error:"+e.getMessage());
        }
        return x;
    }
}  

последняя строкаreturn x не будет работать, если ошибка возникает где-то посередине.

Решение Вопроса

Пытаться:

throw new Exception("transction: " + transNbr, E); 
 thedan24 сент. 2012 г., 17:46
Это именно то, что я искал. Благодарю.

Ваш ответ на вопрос